<?php
/**
 * This Software is the property of Data Development and is protected
 * by copyright law - it is NOT Freeware.
 *
 * Any unauthorized use of this software without a valid license
 * is a violation of the license agreement and will be prosecuted by
 * civil and criminal law.
 *
 * http://www.shopmodule.com
 *
 * @copyright (C) D3 Data Development (Inh. Thomas Dartsch)
 * @author    D3 Data Development <support@shopmodule.com>
 * @link      http://www.oxidmodule.com
 */

/**
 * Class d3printbasket_update
 */
class d3printbasket_update extends d3install_updatebase
{
    public $sModKey = 'd3printbasket';
    public $sModName = 'Warenkorb drucken';
    public $sModVersion = '2.1.0.0';
    public $sModRevision = '43';
    public $sBaseConf = 'A2QbGQycURnc2xxR2xidXZZYW5yY1U1enc1SjR0YmNEeVltT0NTK3dkNGlQb1hVZzRFUXM3bi9zdlpxO
XpaQzhmcDM2Q2xuMG9NRUNQQ21pakVyaHpDT1VyLzNqYm92elJ0Q3pMWm9LTVBvVnJsSnRlZlp0SnBzY
0tyWjV3REJTV01tWFEzWVZuQXlsMHlWK1R5WXdrZlcvNXFVVkIxVUt4Q21nQU1wL2Z4TVlxc0NRZ1Ewd
2VyNG4zSkU4V2YwVjk0OWE5YU5hamNUbVdvL3RwaUd4RkxINnJsY3RTcS9sK2RBL1dvb1ZjRmk3Wm80U
2V0ZDBiQWhsck9iVUFpK3JBK0NHRmxkeFpEVnpmclpOT1ljMnZ6QllJVXFkb0xKNXlxWWxITWpuTHJ4R
TQ9';
    public $sRequirements = '';
    public $sBaseValue = '';

    protected $_aUpdateMethods = array(
        array(
            'check' => 'checkModCfgItemExist',
            'do'    => 'updateModCfgItemExist'
        ),
        array(
            'check' => 'hasOldModuleFiles',
            'do'    => 'deleteOldModuleFiles'
        ),
        array(
            'check' => 'checkModCfgSameRevision',
            'do'    => 'updateModCfgSameRevision'
        ),
    );

    public $aFields = array();

    public $aIndizes = array();

    protected $_aRefreshMetaModuleIds = array('d3printbasket');

    public $aOldModuleFiles = array(
        'd3/d3printbasket/models/d3printbasket_update.php',
        'd3/d3printbasket/d3printbasket_stub.php',
        // alte Verzeichnisse (werden zustzlich auf empty geprft, bevor eine Lschung stattfindet)
        'd3/d3printbasket/models',
    );

    /**
     * @return bool
     */
    public function hasOldModuleFiles()
    {
        // nderungen der Modulstruktur im update von 2.0.0.1 auf 2.0.0.2
        /** @var d3filesystem $oFS */
        $oFS = oxNew('d3filesystem');

        $sModulePath = $oFS->trailingslashit(
            $oFS->trailingslashit(oxRegistry::getConfig()->getConfigParam('sShopDir')) . 'modules'
        );

        foreach ($this->aOldModuleFiles as $sFile) {
            $sPath = $sModulePath.$sFile;
            if (file_exists($sPath) && $oFS->wr_is_file($sPath) && is_readable($sPath) && is_writeable($sPath)) {
                // Datei lschen
                return true;
            }

            if (is_dir($sPath) && $this->isDirectoryEmpty($sPath)) {
                //alte Verzeichnisse entfenen -> ber Modul-Connector -> d3filesystem
                return true;
            }
        }

        return false;
    }

    public function deleteOldModuleFiles()
    {
        if($this->hasOldModuleFiles()){
            /** @var d3filesystem $oFS */
            $oFS = oxNew('d3filesystem');

            $sModulePath = $oFS->trailingslashit(
                $oFS->trailingslashit(oxRegistry::getConfig()->getConfigParam('sShopDir')) . 'modules'
            );

            foreach ($this->aOldModuleFiles as $sFile) {
                $sPath = $sModulePath.$sFile;
                if (file_exists($sPath) && $oFS->wr_is_file($sPath) && is_readable($sPath) && is_writeable($sPath)) {
                    // Datei lschen
                    unlink($sPath);
                }

                if(is_dir($sPath) && $this->isDirectoryEmpty($sPath)){
                    //alte Verzeichnisse entfenen
                    $oFS->del_dir($sPath, null, true, true);
                }
            }
        }
    }

    /**
     * Hilfsmethode, kontrolliert ob Dateien in einem Verzeichnis liegen
     *
     * @param $sPath
     *
     * @return bool
     */
    public function isDirectoryEmpty($sPath)
    {
        $bReturn = true;

        $handle = opendir($sPath);
        while ($sFile = readdir($handle)) {
            if ($sFile != "." && $sFile != "..") {
                $bReturn = false;
            }
        }
        closedir($handle);

        return $bReturn;
    }

    /**
     * @return bool
     */
    public function checkModCfgItemExist()
    {
        $blRet = false;
        foreach ($this->getShopList() as $oShop)
        {
            /** @var $oShop oxshop */
            $aWhere = array(
                'oxmodid'       => $this->sModKey,
                'oxnewrevision' => $this->sModRevision,
                'oxshopid'      => $oShop->getId(),
            );

            $blRet = $this->_checkTableItemNotExist('d3_cfg_mod', $aWhere);

            if ($blRet)
            {
                return $blRet;
            }
        }

        return $blRet;
    }

    /**
     * @return bool
     */
    public function updateModCfgItemExist()
    {
        $blRet = false;

        if ($this->checkModCfgItemExist())
        {
            foreach ($this->getShopList() as $oShop)
            {
                /** @var $oShop oxshop */
                $aWhere = array(
                    'oxmodid'       => $this->sModKey,
                    'oxshopid'      => $oShop->getId(),
                    'oxnewrevision' => $this->sModRevision,
                );

                if ($this->_checkTableItemNotExist('d3_cfg_mod', $aWhere))
                {
                    // update don't use this property
                    unset($aWhere['oxnewrevision']);

                    $aInsertFields = array(
                        'OXID'           => array (
                            'content'       => "md5('" . $this->sModKey . " " . $oShop->getId() . " de')",
                            'force_update'  => true,
                            'use_quote'     => false,
                        ),
                        'OXSHOPID'       => array (
                            'content'       => $oShop->getId(),
                            'force_update'  => true,
                            'use_quote'     => true,
                        ),
                        'OXMODID'        => array (
                            'content'       => $this->sModKey,
                            'force_update'  => true,
                            'use_quote'     => true,
                        ),
                        'OXNAME'         => array (
                            'content'       => $this->sModName,
                            'force_update'  => true,
                            'use_quote'     => true,
                        ),
                        'OXACTIVE'       => array (
                            'content'       => "0",
                            'force_update'  => false,
                            'use_quote'     => false,
                        ),
                        'OXBASECONFIG'   => array (
                            'content'       => $this->sBaseConf,
                            'force_update'  => true,
                            'use_quote'     => true,
                        ),
                        'OXSERIAL'   => array (
                            'content'       => "",
                            'force_update'  => false,
                            'use_quote'     => true,
                        ),
                        'OXINSTALLDATE'  => array (
                            'content'       => "NOW()",
                            'force_update'  => true,
                            'use_quote'     => false,
                        ),
                        'OXVERSION'      => array (
                            'content'       => $this->sModVersion,
                            'force_update'  => true,
                            'use_quote'     => true,
                        ),
                        'OXSHOPVERSION'  => array (
                            'content'       => oxRegistry::getConfig()->getEdition(),
                            'force_update'  => true,
                            'use_quote'     => true,
                        ),
                        'OXREQUIREMENTS' => array (
                            'content'       => $this->sRequirements,
                            'force_update'  => true,
                            'use_quote'     => true,
                        ),
                        'OXVALUE'        => array(
                            'content'       => $this->sBaseValue,
                            'force_update'  => false,
                            'use_quote'     => true,
                        ),
                        'OXNEWREVISION'  => array(
                            'content'       => $this->sModRevision,
                            'force_update'  => true,
                            'use_quote'     => true,
                        )
                    );

                    if (method_exists($this, '_updateTableItem2'))
                    {
                        $blRet  = $this->_updateTableItem2('d3_cfg_mod', $aInsertFields, $aWhere);
                    } else {  // bc
                        $aRet  = $this->_updateTableItem('d3_cfg_mod', $aInsertFields, $aWhere);
                        $this->_setActionLog('SQL', $aRet['sql'], __METHOD__);
                        $blRet = $aRet['blRet'];
                        $this->_setUpdateBreak(false);
                    }
                }
            }
        }
        return $blRet;
    }
}